//	Item 17: Store newed objects in smart pointers in standalone statements.  75

// keep it simple, no headers, just a simple fwd decl for the shared_ptr ...

namespace std {
template <class T> class shared_ptr {};

}

template <class T> class foobar;

class Widget {
public:

	void pWidget( std::shared_ptr<Widget>, int );
	void pWidget( Widget , int );
	int priority();
} ;


void Widget::pWidget( Widget w, int p )
{

	{
		std::shared_ptr<Widget> w( new Widget );	// good
		pWidget( w, p );

		foobar<Widget> w( new Widget );				// bad
		pWidget( w, p );
	}

	{

		 pWidget( new Widget, p );	// bad
	}
}
